/*****************************************
  xjump version 2

  game.c   ړE`֌W

  (C) July 28, 1997  ROYALPANDA
*****************************************/

/* modified by shinichiro.h in 020820 */

#include<stdio.h>
#include<math.h>

#include"xjump.h"


/* }N */

#define max( a,b ) ( (a) > (b) ? (a) : (b) )
#define min( a,b ) ( (a) < (b) ? (a) : (b) )

/* ϐ */

static int T_speed,T_count;   /* XN[Xs[h֌W */
 

/* ݒ^`悷 */

static void make_floor( int y )
{
  int f,x1,x2,l,fvec;
  static int fpos = WIDTH/2;
  SDL_Rect src, dst;

  f = Floor_top - y;

  if( f % 250 == 0 ){

    floor_l(y) = 16;
    floor_r(y) = WIDTH*16-17;

	src.x = 0; src.y = 0; src.w = WIDTH*16; src.h = 16;
	dst.x = 0; dst.y = y*16;
	SDL_BlitSurface(Floor_p, &src, Disp, &dst);

    return;
  }

  if( f % 5 == 0 ){
	if (Is_replay) {
	  x1 = pop_replay(&Floor_replay);
	  x2 = pop_replay(&Floor_replay);
	}
	else {
	  fvec = (rnd(2)*2-1) * ( rnd( (WIDTH-11)/4 ) + (WIDTH-11)/4 );

	  fpos = ( fpos + fvec +WIDTH-11 ) % (WIDTH-11);
    
	  x1 = ( fpos+5 - rnd( 3 ) - 2);
	  x2 = ( fpos+5 + rnd( 3 ) + 2);

	  push_replay(&Floor_replay, x1);
	  push_replay(&Floor_replay, x2);
	}

    x1 = x1 * 16;
    x2 = x2 * 16 + 15;

    floor_l(y) = x1;
    floor_r(y) = x2;

	src.x = x1;	src.y = 0; src.w = x2-x1+1; src.h = 16;
	dst.x = x1; dst.y = y*16;
	SDL_BlitSurface(Floor_p, &src, Disp, &dst);

  }else{
    floor_l(y) = WIDTH*16;
    floor_r(y) = 0;
  }
}


/* l\ */

static void draw_hero( void )
{
  int pic;
  int sx,sy;
  SDL_Rect src, dst;

  pic = Hero.pic * 2 + Hero.dir;
  sx = ( pic & 3 ) * 32;
  sy = ( pic >> 2 ) * 32;

  src.x = sx; src.y = sy; src.w = 32; src.h = 32;
  dst.x = Hero.x; dst.y = Hero.y;
  SDL_BlitSurface(Char_p, &src, Disp, &dst);

}


/* l */

static void del_hero( void )
{
  recover_scr( Hero.x, Hero.y, 32, 32 );
}


/* PCXN[ */

static void scroll_up( void )
{
  int i,x,width,y;
  SDL_Rect src, dst;

  for( y = Floor_top % 5 ; y < HEIGHT ; y += 5 ){
    x = floor_l(y);
    width = floor_r(y)-x+1;

	src.x = x; src.y = 0; src.w = width; src.h = 16;
	dst.x = x; dst.y = y*16;
	SDL_BlitSurface(Back_p, &src, Disp, &dst);

    if( y < HEIGHT-1 ) {
	  dst.y = y*16+16;
	  SDL_BlitSurface(Floor_p, &src, Disp, &dst);
	}
  }

  Floor_top++;

  if( --Map_index < 0 )
    Map_index = HEIGHT - 1;

  make_floor( 0 );

  Hero.y += 16;
}


/* l̏ɂ邩 */

static int stand( void )
{
  int y;

  if( Hero.vy < 0 )
    return 0;

  y = ( ( Hero.y + 32 ) / 16 );
  if( y >= HEIGHT )
    return 0;

  if( floor_l(y) < Hero.x+24 && Hero.x+8 < floor_r(y) )
    return 1;
  else
    return 0;
}


/* l̈ړ */

int move( void )
{
  int acc,st,floor;

  del_hero();

  if( T_speed < 5000 )
    T_speed++;

  T_count += T_speed;
  if( T_count > 20000 ){
    T_count -= 20000;
    scroll_up();
  }

  Hero.x += Hero.vx / 2;
  Hero.y += Hero.vy;

  if( Hero.x < 16 ){
    Hero.x = 16;
    Hero.vx = -Hero.vx/2;
  }else if( Hero.x > WIDTH*16-48 ){
    Hero.x = WIDTH*16-48;
    Hero.vx = -Hero.vx/2;
  }

  if( Hero.y < 80 ){

    scroll_up();
    T_count = 0;

  } else if( Hero.y >= HEIGHT*16 )
    return DEAD;

  if( ( st = stand() ) ){
    acc = 3;
    floor = (Floor_top - Hero.y / 16)/5 + 1;

    Hero.pic &= 1;

    Hero.y = (Hero.y / 16 ) * 16;
    Hero.vy = 0;

    if( ++Hero.g_count == 5 ){
      Hero.g_count = 0;
      Hero.pic ^= 1;
    }

    if( Key[ KEY_UP ] ){
      Hero.jump = abs(Hero.vx)/4+7;
      Hero.vy = -Hero.jump/2-12;
      Hero.pic = 2;
      st = 0;
    }

  }else{
    acc = 2;
    floor = 0;
  }

  if( Key[ KEY_LEFT ] ){
    Hero.vx -= acc;
    if( Hero.vx < -32 )
      Hero.vx = -32;
    Hero.dir = 0;
  }else if( Key[ KEY_RIGHT ] ){
    Hero.vx += acc;
    if( Hero.vx > 32 )
      Hero.vx = 32;
    Hero.dir = 1;
  }else if( st ){
    if( Hero.vx < -2 )
      Hero.vx+=3;
    else if( Hero.vx > 2 )
      Hero.vx-=3;
    else
      Hero.vx = 0;
  }

  if( !st ){
    if( Hero.jump ){
      Hero.vy = -Hero.jump/2-12;
      if( Key[ KEY_UP ] )
	Hero.jump--;
      else
	Hero.jump = 0;
    }else{
      Hero.vy+=2;
      if( Hero.vy > 0 )
	Hero.pic = 3;

      if( Hero.vy > 16 )
	Hero.vy = 16;
    }
  }

  draw_hero();

  return floor;
}


/* Q[ */

void init_game( void )
{
  int x,y;

  Floor_top = HEIGHT - 4;

  for ( y = 0 ; y < HEIGHT ; y++ ){
	SDL_Rect src, dst;
	src.x = 0; src.y = 0; src.w = WIDTH*16; src.h = 16;
	dst.x = 0; dst.y = y*16;
	SDL_BlitSurface(Back_p, &src, Disp, &dst);
    make_floor(y);
  }

  Hero.x = WIDTH * 8 - 16;
  Hero.y = (HEIGHT - 4)*16-32;
  Hero.vx = Hero.vy = 0;
  Hero.pic = 0;
  Hero.dir = 0;
  Hero.g_count = 0;

  T_speed = 200;
  T_count = 0;

  Key[ KEY_UP ] = 0;
  draw_hero();
}


/* ʂC */

void recover_scr( int x, int y, int width, int height )
{
  int xl,xr,y2;
  SDL_Rect src, dst;

  y2 = (y+height-1) / 16;
  y /= 16;

  for( ; y <= y2 ; y++ ){
	src.x = x; src.y = 0; src.w = width; src.h = 16;
	dst.x = x; dst.y = y*16;
	SDL_BlitSurface(Back_p, &src, Disp, &dst);

    xl = max( x,floor_l(y) );
    xr = min( x+width-1,floor_r(y) );

    if( xl < xr ) {
	  src.x = xl; src.y = 0; src.w = xr-xl+1; src.h = 16;
	  dst.x = xl; dst.y = y*16;
	  SDL_BlitSurface(Floor_p, &src, Disp, &dst);
	}
  }
}
