/*****************************************
  xjump version 2

  main.c    ^ X Intrinsics֌W

  (C) Oct 28, 1997  ROYALPANDA
*****************************************/

/* modified by shinichiro.h in 020820 */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include"xjump.h"
#include"record.h"
#include"replay.h"

#include<SDL.h>

#ifdef UNIX
# include<unistd.h>
# include<sys/types.h>
#endif

#define TITLE 0
#define GAME  1
#define OVER  2
#define PAUSE 3

#define SPEED 30

Uint32 LastTick;
Uint32 CountTick;
Uint32 CountStartTick;
Uint32 LastSec = 0;

static char *GraphFile = NULL;     /* [U[OtBbNt@C */
static char *ReplayFile = NULL;

static int GameMode; /* [h (0^Cg  1Q[  2Q[I[o[ 3|[Y) */

static int Sc_now;

/* vg^Cv錾 */

static void timi();


/* O[oϐ */

SDL_Surface* Screen;

SDL_Surface* Disp;           /* fBXvC\ */

SDL_Surface* Char_p;           /* LN^ */
SDL_Surface* Floor_p;          /*  */
SDL_Surface* Back_p;           /* wi */
SDL_Surface* Score_p;

SDL_Surface* Ascii_p;
SDL_Surface* Number_p;

SDL_Surface* TitleText_p;
SDL_Surface* CopyrightText_p;
SDL_Surface* FloorText_p;
SDL_Surface* SecText_p;
SDL_Surface* GameoverText_p;
SDL_Surface* PauseText_p;

SDL_Surface* Swap =0;     /* XbvȂ񂩂Ɏg܂ */

int Key[3] = {0,0,0};    /* L[̏ */

hero_t Hero;             /* l̏ */

int Floor_L[ HEIGHT ];   /* ̏ */
int Floor_R[ HEIGHT ];

int Map_index;
int Floor_top;

record_t Record[ RECORD_ENTRY ];  /* nCXRAXg                    */
int Record_entry;                 /* nCXRAXg̐  -1:L^Ȃ */

char *Myname;   /* vO */

replay_t Floor_replay;
replay_t Move_replay;

int Is_replay;

/* SDL_LoadBMP̃wpBfBNgӏw肵Ȃėǂ */
static SDL_Surface* load_bmp(const char* filename)
{
  char buf[256];

  snprintf(buf, 255, "bmp/%s", filename);
#ifdef UNIX
  if (is_file_exist(buf))
	return SDL_LoadBMP(buf);

  snprintf(buf, 255, "%s/%s", BMP_DIR, filename);
  if (is_file_exist(buf))
	return SDL_LoadBMP(buf);

  fprintf(stderr, "%s: not found\n", filename);
  exit(1);

#else
  return SDL_LoadBMP(buf);
#endif
}


static void put_num(int s, int x, int y)
{
  SDL_Rect src, dst;
  int n, i, j;

  for (i = 10, j = 3; i <= 10000; i *= 10, j--) {
	n = (s % i) * 10 / i;
	s -= n;

	src.x = n * 15 -1; src.y = 0; src.w = 15; src.h = 18;
	dst.x = j * 16 + x; dst.y = y;
	SDL_BlitSurface(Number_p, &src, Screen, &dst);
  }
}


/* XRA\ */

static void put_score( void )
{
  put_num(LastSec, 390, 90);

  put_num(Sc_now, 190, 90);
}


static void draw_text(const char* text, int x, int y)
{
  int i = 0;
  SDL_Rect src, dst;

  src.y = 0; src.w = 14; src.h = Ascii_p->h;
  dst.y = y;

  while (*text != 0) {
	/* ASCII */
	src.x = (*text-32) * 14;
	dst.x = i * 10 + x;
	SDL_BlitSurface(Ascii_p, &src, Screen, &dst);

	text++;
	i++;
  }
}


/* nCXRAʍ쐬 */

static void make_score( void )
{
  int i;
  char buf[256];

  if( Record_entry == -1 )
    return;

  draw_text("RANK FLOOR  SEC   NAME", 60, 260);
  draw_text("---- ----- ----- ---------------------------", 60, 280);

  for( i = 0 ; i < Record_entry ; i++ ) {
    snprintf(buf, 255, "%4d %4d  %4d  %-31.31s\n",
			 i+1, Record[i].score,Record[i].second,Record[i].name );
	draw_text(buf, 60, 300 + i * 20);
  }
}


/* ^C}[X^[g */

static void set_timer( void )
{
  LastTick = SDL_GetTicks();
}


static void save_replay_data() {
  FILE* fp;

#ifdef UNIX
  fp = fopen(REPLAY_FILE, "wb");
  if (fp == 0) fp = fopen("replay.dat", "wb");
#else
  fp = fopen("replay.dat", "wb");
#endif

  if (fp == 0) {
	fprintf(stderr, "cannot save replay\n");
	return;
  }

  save_replay(&Move_replay, fp);
  save_replay(&Floor_replay, fp);

  fclose(fp);
}

/* Q[I[o[ */

static void gameover( void )
{
  SDL_Rect dst;

  dst.x = 200; dst.y = 226;
  SDL_BlitSurface(GameoverText_p, 0, Screen, &dst);
  GameMode = OVER;

  if (!Is_replay) save_replay_data();

  quit_replay(&Floor_replay);
  quit_replay(&Move_replay);

  if (!Is_replay) save_record( Sc_now, LastSec );
}


/* ^Cg */

static void title( void )
{
  SDL_Rect rect;

  SDL_FillRect(Disp, 0, SDL_MapRGB(Disp->format, 255,255,255));
  rect.x = 1; rect.y = 1; rect.w = Disp->w-2; rect.h = Disp->h-2;
  SDL_FillRect(Disp, &rect, SDL_MapRGB(Disp->format, 0,0,0));

  GameMode = TITLE;

  put_score();

  make_score();
}



/* ^C}[[` */

static void timi()
{
  int floor;
  static int timer;

  switch( GameMode ){

  case GAME:
    floor = move();
    if( floor == DEAD ){
      gameover();
      timer = 0;
    }
    else if( floor > Sc_now ){
      Sc_now = floor;
      if( Sc_now > 9999 )
		Sc_now = 9999;
      put_score();
    }
    break;
    
  case OVER:
    if( ++timer > 250 )
      title();
    break;
  }
}


/* vOI (ANVnh) */

static void quit_game()
{
  if (SDL_JoystickOpened(0)) {
	SDL_JoystickClose(0);
  }
  SDL_Quit();
  exit(0);
}


static void load_replay_data() {
  FILE* fp =0;

  if (ReplayFile) {
	fp = fopen(ReplayFile, "rb");
  }

  if (fp == 0) {
#ifdef UNIX
	fp = fopen(REPLAY_FILE, "rb");
	if (fp == 0) fp = fopen("replay.dat", "rb");
#else
	fp = fopen("replay.dat", "rb");
#endif
  }

  if (fp == 0) {
	fprintf(stderr, "cannot open replay start normal mode.\n");
	Is_replay = 0;
	return;
  }

  load_replay(&Move_replay, fp);
  load_replay(&Floor_replay, fp);
}

static void init_replay_data() {
  /* p ŃX^[gƃvC[h */
  if (Key[KEY_UP]) Is_replay = 0;
  else Is_replay = 1;

  init_replay(&Floor_replay);
  init_replay(&Move_replay);

  if (Is_replay) {
	load_replay_data();
  }
}

/* X^[g (ANVnh) */

static void start_game()
{
  switch( GameMode ){
  case TITLE:
	init_replay_data();

    init_game();
    Sc_now = 0;
    GameMode = GAME;

    set_timer();

	CountStartTick = LastTick;
	CountTick = 0;

    break;

  case OVER:
    title();
    break;
  }
}


/* |[Y (ANVnh) */

static void pause_game()
{
  SDL_Rect dst;

  if( GameMode == GAME ){
	dst.x = 224; dst.y = 225; dst.w = PauseText_p->w; dst.h = PauseText_p->h;
	Swap = SDL_CreateRGBSurface(SDL_SWSURFACE, dst.w, dst.h, 16, 0,0,0,0);
	SDL_BlitSurface(Screen, &dst, Swap, 0);
	SDL_BlitSurface(PauseText_p, 0, Screen, &dst);

    GameMode = PAUSE;

	CountTick += LastTick - CountStartTick;
  }else if( GameMode == PAUSE ){
	dst.x = 224; dst.y = 225; dst.w = Swap->w; dst.h = Swap->h;
	SDL_BlitSurface(Swap, 0, Screen, &dst);
	SDL_FreeSurface(Swap);
	Swap = 0;

    GameMode = GAME;

	set_timer();
	CountStartTick = LastTick;
  }
}


/* ACR̐ݒ */

static void set_icon( void )
{
  SDL_Surface* icon;

  icon = load_bmp("icon.bmp");
  SDL_SetColorKey(icon, SDL_SRCCOLORKEY, SDL_MapRGB(icon->format, 255,0,255));
  SDL_WM_SetIcon(icon, 0);
  SDL_FreeSurface(icon);
}


/* wv */

static void help()
{
  fprintf( stderr,"Usage: %s [options]\n",Myname );
  fprintf( stderr,"\t-graphic \"file\"\t\tuse your xpm graphic \"file\"\n" );
  fprintf( stderr,"\t-help\t\t\tshow this messages.\n" );
}


/* R}hCIvV */

static void option( int argc, char **argv )
{
  int i;

  for( i = 1 ; i < argc ; i++ ){
	if( strcmp( argv[i],"-graphic" ) == 0 ){
      GraphFile = argv[++i];
      continue;
    }

    if( strcmp( argv[i],"-help" ) == 0 ){
      help();
      exit(0);
    }

	ReplayFile = argv[i];
  }

  if (!GraphFile) GraphFile = "picture.bmp";
}

/* 摜ǂݍ */

static void init_graph( void )
{
  int x;
  SDL_Rect src, dst;

  Char_p = load_bmp(GraphFile);
  SDL_SetColorKey(Char_p, SDL_SRCCOLORKEY,
				  SDL_MapRGB(Char_p->format, 255,0,255));

  Floor_p = SDL_CreateRGBSurface(SDL_SWSURFACE, WIDTH*16, 16, 16, 0,0,0,0);
  src.x = 128; src.y = 16; src.w = 16; src.h = 16;
  dst.x = 0; dst.y = 0;
  SDL_BlitSurface(Char_p, &src, Floor_p, &dst);
  src.y = 32; dst.x = WIDTH*16-16;
  SDL_BlitSurface(Char_p, &src, Floor_p, &dst);

  src.y = 48;
  for( x = 16 ; x < WIDTH*16-16 ; x+=16 ) {
	dst.x = x;
	SDL_BlitSurface(Char_p, &src, Floor_p, &dst);
  }

  Back_p = SDL_CreateRGBSurface(SDL_SWSURFACE, WIDTH*16, 16, 16, 0,0,0,0);

  src.x = 128; src.y = 16;
  dst.x = 0; dst.y = 0;
  SDL_BlitSurface(Char_p, &src, Back_p, &dst);
  src.y = 32; dst.x = WIDTH*16-16;
  SDL_BlitSurface(Char_p, &src, Back_p, &dst);
  src.y = 0;
  for( x = 16 ; x < WIDTH*16-16 ; x+=16 ) {
	dst.x = x;
	SDL_BlitSurface(Char_p, &src, Back_p, &dst);
  }

  Ascii_p = load_bmp("font.bmp");
  SDL_SetColorKey(Ascii_p, SDL_SRCCOLORKEY,
				  SDL_MapRGB(Ascii_p->format, 0,0,0));
  Number_p = load_bmp("number.bmp");

  TitleText_p = load_bmp("title.bmp");
  CopyrightText_p = load_bmp("copyright.bmp");
  FloorText_p = load_bmp("floor.bmp");
  SecText_p = load_bmp("sec.bmp");
  GameoverText_p = load_bmp("gameover.bmp");
  PauseText_p = load_bmp("pause.bmp");

  dst.x = 64; dst.y = 16;
  SDL_BlitSurface(TitleText_p, 0, Screen, &dst);
  dst.x = 70; dst.y = 550;
  SDL_BlitSurface(CopyrightText_p, 0, Screen, &dst);
  dst.x = 80; dst.y = 85;
  SDL_BlitSurface(FloorText_p, 0, Screen, &dst);
  dst.x = 300; dst.y = 85;
  SDL_BlitSurface(SecText_p, 0, Screen, &dst);
}


static void event()
{
  SDL_Event ev;
  SDLKey k;
  char keys;

  while (SDL_PollEvent(&ev)) {
	switch (ev.type) {
	case SDL_QUIT:
	  quit_game();
	  break;

	case SDL_KEYDOWN:
	case SDL_KEYUP:
	  k = ev.key.keysym.sym;
	  if (k == 'q' && (ev.key.keysym.mod&KMOD_LSHIFT)) quit_game();
	  else if (k == 'p' && ev.key.type == SDL_KEYDOWN) {
		pause_game();
		start_game();
	  }
	  else if (k == 'j' || k == '4' || k == SDLK_LEFT)
		Key[KEY_LEFT] = (ev.key.type == SDL_KEYDOWN);
	  else if (k == 'k' || k == '6' || k == SDLK_RIGHT)
		Key[KEY_RIGHT] = (ev.key.type == SDL_KEYDOWN);
	  else if (k == 'z' || k == ' ' || k == '8' || k == SDLK_LEFT)
		Key[KEY_UP] = (ev.key.type == SDL_KEYDOWN);

	  break;

	case SDL_MOUSEBUTTONDOWN:
	  if (ev.button.button == SDL_BUTTON_LEFT) Key[KEY_UP] = 1;
	  else if (ev.button.button == SDL_BUTTON_MIDDLE) Key[KEY_LEFT] = 1;
	  else if (ev.button.button == SDL_BUTTON_RIGHT) Key[KEY_RIGHT] = 1;

	  break;

	case SDL_MOUSEBUTTONUP:
	  if (ev.button.button == SDL_BUTTON_LEFT) Key[KEY_UP] = 0;
	  else if (ev.button.button == SDL_BUTTON_MIDDLE) Key[KEY_LEFT] = 0;
	  else if (ev.button.button == SDL_BUTTON_RIGHT) Key[KEY_RIGHT] = 0;

	  break;

	case SDL_JOYAXISMOTION:
	  if (ev.jaxis.axis == 0) {
		if (ev.jaxis.value > 3200) Key[KEY_RIGHT] = 1;
		else if (ev.jaxis.value < -3200) Key[KEY_LEFT] = 1;
		else {
		  Key[KEY_RIGHT] = 0;
		  Key[KEY_LEFT] = 0;
		}
	  }
	  break;

	case SDL_JOYBUTTONDOWN:
	  Key[KEY_UP] = 1;
	  break;

	case SDL_JOYBUTTONUP:
	  Key[KEY_UP] = 0;
	  break;
	}

	if (Key[KEY_UP]) start_game();
  }

  if (GameMode == GAME) {
	if (Is_replay) {
	  keys = pop_replay(&Move_replay);
	  Key[KEY_UP] = keys & 1;
	  Key[KEY_RIGHT] = keys & 2;
	  Key[KEY_LEFT] = keys & 4;
	}
	else {
	  keys = 0;
	  if (Key[KEY_UP]) keys |= 1;
	  if (Key[KEY_RIGHT]) keys |= 2;
	  if (Key[KEY_LEFT]) keys |= 4;
	  push_replay(&Move_replay, keys);
	}
  }
}


static void timer()
{
  Uint32 s;
  Uint32 ticks;

  ticks = SDL_GetTicks();
  LastTick += SPEED;
  if (ticks < LastTick) {
	SDL_Delay(LastTick-ticks);
  }

  if (GameMode == GAME) {
	s = (CountTick + LastTick - CountStartTick) / 1000;
	if (LastSec != s) {
	  put_num(s, 390, 90);
	  LastSec = s;
	}
  }
}


static void main_loop()
{
  while (1) {
	timi();
	event();
	timer();

	SDL_UpdateRect(Screen, 0,0,0,0);
  }
}


/* C */

int main( int argc,char **argv )
{
#ifdef UNIX
  uid_t uid;
#endif

  Uint8* pixel;

  if( (Myname = argv[0]) == NULL )
    Myname = "sdljump";

#ifdef UNIX
  uid = geteuid();
  seteuid(getuid());
#endif

  if (SDL_Init(SDL_INIT_VIDEO) < 0) {
	fprintf(stderr, "cannot init video: %s\n", SDL_GetError());
	exit(1);
  }

  if (SDL_Init(SDL_INIT_JOYSTICK) < 0) {
	fprintf(stderr, "cannot init joystick\n");
  }
  else {
	SDL_JoystickOpen(0);
  }

  Screen = SDL_SetVideoMode(546, 591, 16, SDL_SWSURFACE);
  if (Screen == 0) {
	fprintf(stderr, "cannot create window: %s\n", SDL_GetError());
  }

  pixel = (Uint8 *)Screen->pixels + 146 * Screen->pitch + 16*2;
  Disp = SDL_CreateRGBSurfaceFrom(pixel, 512, 384, 16,
								  Screen->pitch, 0,0,0,0);
  SDL_WM_SetCaption(Myname, 0);

  option( argc,argv );

#ifdef UNIX
  seteuid( uid );
#endif

  init_graph();
  set_icon();
  Map_index = 0;

  init_record();

  srnd();

  title();

  main_loop();

  return 0;
}
